<?php
  /* ***** BEGIN LICENSE BLOCK *****
  * This is a plugin for DotClear.
  *
  * DotClear is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  * 
  * DotClear is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with DotClear; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * ***** END LICENSE BLOCK *****
  */
  /*
  http://www.dotclear.net/trac/wiki/DotClear/ContribBazar
  http://blog.triptik.org/index.php/2005/03/17/10-podcaster-avec-dotclear
  
  La balise <enclosure url="http://...demo.mp3" type="audio/mpeg" length="999" />
  est gnre si le billet contient une rfrence de type
  <a href="http://...demo.mp3" rel="enclosure">podcast</a>
  ou l'adresse du fichier de podcast comprend l'attribut rel ayant la valeur "enclosure"
  
  cette version de rss2.php ne ncessite pas le package curl
  elle gre le type MIME (iTunes essentiellement)
  */
 require dirname(__FILE__).'/inc/prepend.php';
 require dirname(__FILE__).'/layout/lib.cache.php';
 require dirname(__FILE__).'/layout/class.xblog.php';
 require dirname(__FILE__).'/layout/class.xblogpost.php';
 require dirname(__FILE__).'/layout/class.xblogcomment.php';
 
 $type = (!empty($_GET['type']) && $_GET['type'] == 'co') ? 'co' : 'blog';
 $cat = (!empty($_GET['cat'])) ? $_GET['cat'] : '';
 
 # Connexion MySQL
 $con = new Connection(DB_USER,DB_PASS,DB_HOST,DB_DBASE);
 
 if ($con->error()) { exit; }
 
 # Cration de l'objet de type weblog avec uniquement les billets
 # publis
 $blog = new xblog($con,DB_PREFIX,1,dc_encoding);
 $blog->rs_blogpost = 'xblogpost';
 $blog->rs_blogcomment = 'xblogcomment';
 
 $blog->setURL('post','http://'.$_SERVER['SERVER_NAME'].dc_blog_url.dc_format_post_url);
 
 # Si type = co on fait un fil des commentaires
 if ($type == 'co')
 {
  if (!empty($_GET['post'])) {
         $comments = $blog->getComments($_GET['post'],'DESC');
  } else {
         $comments = $blog->getComments('','DESC',20);
  }
  
  $title = dc_blog_name.' - Commentaires';
  $ts = time();
  $items = $seq = '';
 }
 else
 {
  # Dernires nouvelles
  $news = $blog->getLastNews(10,$cat);
  
  $ts = strtotime($blog->getEarlierDate());
  $title = dc_blog_name;
 }
 
 # Cache HTTP
 if (dc_http_cache && defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W)
 {
  $mod_files = get_included_files();
  $mod_files[] = DC_UPDATE_FILE;
  $mod_files[] = dirname(__FILE__).'/conf/dotclear.ini';
  
  cache::http($mod_files);
 }
 function get_mime_type($url)
  {
  	ereg("\.([^\.]*$)", $url, $elts);
    $ext = $elts[1];
  	if ($ext == '') return false;
    # traitement du type MIME
    $ext = strtolower($ext);
    if ($ext == 'mp3') $type = 'audio/mpeg'; # Fichier audio MPEG
    elseif ($ext == 'm4a') $type = 'audio/x-m4a'; # Fichier audio AAC
    elseif ($ext == 'mp4') $type = 'audio/mp4'; # Fichier de donnes MPEG-4
    elseif ( ($ext == 'mov') OR ($ext == 'qt') ) $type = 'video/quicktime'; # Squence QuickTime mov,qt
    elseif ($ext == 'pdf') $type = 'application/pdf'; # Acrobat
    # fin des extensions types pour iTunes 4.9
    elseif ( ($ext == 'au') OR ($ext == 'snd') ) $type = 'audio/basic'; # Fichier audio
    elseif ( ($ext == 'aif') OR ($ext == 'aiff') OR ($ext == 'aifc') ) $type = 'audio/x-aiff'; # Format audio AIFF
    elseif ($ext == 'wav') $type = 'audio/x-wav'; # 	Fichier audio Windows
    elseif ($ext == 'wma') $type = 'audio/x-ms-wma'; # 	Fichier audio Windows
    elseif ($ext == 'swf') $type = 'application/x-shockwave-flash'; # Macromedia Flash movie
    elseif ($ext == 'avi') $type = 'video/msvideo'; # Vido Microsoft Windows
    elseif ($ext == 'wmv') $type = 'video/x-ms-wmv'; # Vido Microsoft Windows
    elseif ($ext == 'asf') $type = 'video/x-ms-asf'; # Vido Microsoft Windows
    elseif ( ($ext == 'mpeg') OR ($ext == 'mpg') OR ($ext == 'mpe') ) $type = 'video/mpeg'; # Fichier vido MPEG
    elseif ($ext == 'flv') $type = ' video/x-flv'; # Fichier vido FLV
    else $type = 'unknown';
    return $type;
  }
 function get_remote_file($url)
  {
    $hdrs = array('Last-Modified:', 'Content-Length:');
    $infos = array();
    $url_info=parse_url($url);
    $port = isset($url_info['port']) ? $url_info['port'] : 80;
    $fp=fsockopen($url_info['host'], $port, $errno, $errstr, 30);
    if($fp) {
      $head = "HEAD ".@$url_info['path']."?".@$url_info['query'];
      $head .= " HTTP/1.0\r\nHost: ".@$url_info['host']."\r\n\r\n";
      fputs($fp, $head);
      while(!feof($fp)) {
        if($header=trim(fgets($fp, 1024))) {
          if ( substr($header, 0, strlen($hdrs[0])) == $hdrs[0] )
            $infos[0] = trim(str_replace($hdrs[0], '', $header));
          if ( substr($header, 0, strlen($hdrs[1])) == $hdrs[1] )
            $infos[1] = trim(str_replace($hdrs[1], '', $header));
        }
      }
      if (count($infos) == 2) {
        return $infos;
      } else {
        return false;
      }
    } else {
      return false;
    }
  } # fin de get_remote_file
 
 function getRSS2PostItem(&$news)
 {
  if ($news->f('post_chapo') != '') {
    $desc = strip_tags($news->f('post_chapo'));
  } else {
    $desc = util::cutString(strip_tags($news->f('post_content')),200).'...';
  }
 $enclosure_string="";
 $content = $news->f('post_chapo')."<br />".$news->f('post_content');
 if( preg_match_all( "((http://(([[:punct:]]|[[:alnum:]])*))\"(.*)?(rel=\"enclosure\"))" ,
 	$content,$result,PREG_SET_ORDER));
  {
    for ($i=0; $i< count($result); $i++)
    {      
    if ( ($infos = get_remote_file($result[$i][1])) !== false)
    	$length = $infos[1];
    else $length=0;
    if ( ($type = get_mime_type($result[$i][1])) === false)
    	$type = 'unknown';
    $enclosure_string .="<enclosure url=\"".$result[$i][1]."\" type=\"".$type."\" length=\"".$length."\" />";
    }
  }
  return
  '<item>'."\n".
  '  <title>'.$news->blog->toXML($news->f('post_titre'))."</title>\n".
  '  <link>'.$news->getPermURL().'</link>'."\n".
  '  <pubDate>'.strftime('%a, %d %b %Y %H:%M:%S GMT',$news->getTS())."</pubDate>\n".
  '  <guid>'.$news->getPermURL()."</guid>\n".
  '  <dc:creator>'.htmlspecialchars($news->getUserCN())."</dc:creator>\n".
  '  <dc:subject>'.htmlspecialchars($news->f('cat_libelle'))."</dc:subject>\n".
  '  <description>'.$news->blog->toXML($desc)."</description>\n".
  '  <content:encoded><![CDATA['.$news->f('post_chapo').' '.$news->f('post_content')."]]>\n".
  '  </content:encoded>'."\n".
  '  '.$enclosure_string."\n".
  '</item>'."\n";
 }
 
 function getRSS2CommentItem(&$comments)
 {
  $tb = (boolean) $comments->f('comment_trackback');
  
  $desc = util::cutString(strip_tags($comments->getContent()),300).'...';
  
  return
  '<item>'."\n".
  '  <title>'.($tb ? 'trackback - ' : '').
  $comments->blog->toXML($comments->f('post_titre')).' - '.
  $comments->blog->toXML($comments->f('comment_auteur'))."</title>\n".
  '  <link>'.$comments->getPermURL()."</link>\n".
  '  <pubDate>'.strftime('%a, %d %b %Y %H:%M:%S GMT',$comments->getTS())."</pubDate>\n".
  '  <guid>'.$comments->getPermURL()."</guid>\n".
  '  <dc:creator>'.htmlspecialchars($comments->f('comment_auteur'))."</dc:creator>\n".
  '  <description>'.$comments->blog->toXML($desc)."</description>\n".
  '  <content:encoded><![CDATA['.$comments->getContent()."]]></content:encoded>\n".
  '</item>'."\n";
 }
 
 header('Content-Type: text/xml; charset='.dc_encoding);
 echo '<?xml version="1.0" encoding="'.dc_encoding.'" ?>'."\n";
 ?>
 <rss version="2.0" xml:lang="en"
 xmlns:dc="http://purl.org/dc/elements/1.1/"
 xmlns:content="http://purl.org/rss/1.0/modules/content/"
 xmlns:sy="http://purl.org/rss/1.0/modules/syndication/" >
 <channel>
   <title><?php echo $blog->toXML($title); ?></title>
   <link>http://<?php echo $_SERVER['SERVER_NAME'].dc_blog_url; ?></link>
   <description><?php echo htmlspecialchars(dc_blog_desc); ?></description>
 
   <pubDate><?php echo strftime('%a, %d %b %Y %H:%M:%S GMT',$ts); ?></pubDate>
   <generator>http://www.dotclear.net/</generator>
 
   <sy:updatePeriod>daily</sy:updatePeriod>
   <sy:updateFrequency>1</sy:updateFrequency>
   <sy:updateBase><?php echo date('Y-m-d\\TH:i:s+00:00',$ts); ?></sy:updateBase>
 <?php
 if ($type == 'co')
 {
  while(!$comments->EOF()) {
         echo getRSS2CommentItem($comments);
         $comments->moveNext();
  }
 }
 else
 {
  while(!$news->EOF()) {
         echo getRSS2PostItem($news);
         $news->moveNext();
  }
 }
 
 $con->close();
 ?>
 </channel>
 </rss>
